import java.util.* ;

public class Turing {
  static String space39 = "                                       " ;
  public static String run ( HashMap code, String input, int debug ) throws Exception {
    Band band = new Band ( input ) ;
    String zustand = "a" ;
    while ( ! zustand.equals ( "e" ) ) {
      if ( debug > 1 ) System.err.println ( band.print ( 40, 40 ) ) ;
      if ( debug > 1 ) System.err.println ( "<" + space39 + "^" + space39 + ">" ) ;
      TuringCommand command = (TuringCommand)code.get ( zustand ) ;
      if ( command == null ) throw new Exception ( "Unbekannter Zustand: " + zustand ) ;
      String value = band.value ;
      if ( debug > 0 ) System.err.println ( zustand + ": " + command.print ( value ) ) ;
      band.value = command.write ( value ) ;
      switch ( command.move ( value ) ) {
        case 'L' : band = band.left () ; break ;
	case 'R' : band = band.right () ;
      }
      zustand = command.state ( value ) ;
    }
    if ( debug > 1 ) System.err.println ( band.print ( 40, 40 ) ) ;
    if ( debug > 1 ) System.err.println ( "<" + space39 + "^" + space39 + ">" ) ;
    return band.output () ;
  }
}
