import java.io.* ;
import java.util.* ;

public class TuringCommandParser {

  public static HashMap parse ( BufferedReader r ) throws Exception {
    HashMap data = new HashMap () ;
    String tmp = r.readLine () ;
    while ( r.ready () ) {
      String s = tmp ;
      tmp = r.readLine () ;
      while ( r.ready() && tmp.indexOf ( ':' ) < 0 ) {
        s += "\n" + tmp ;
        tmp = r.readLine () ;
      }
      String index = s.substring ( 0, s.indexOf ( ':' ) ) ;
      s = s.substring ( s.indexOf ( ':' ) + 1 ) ;
      data.put ( index, new TuringCommand ( s ) ) ;
    }
    return data ;
  }

}
