import java.util.* ;

public class PostCommand {

  public char kind ;
  public String value ;
  public String state1 ;
  public String state2 ;

  public PostCommand ( String str ) {
    str = str.trim() ;
    kind = str.charAt ( 0 ) ;
    str = str.substring ( 1 ).trim() ;
    StringTokenizer st = new StringTokenizer ( str, "," ) ;
    switch ( kind ) {
      case '!' : break ;
      case '?' : value = st.nextToken().trim() ;
            state1 = st.nextToken().trim() ;
	    state2 = st.nextToken().trim() ;
	    break ;
      case 'M' :
      case '>' : value = st.nextToken().trim() ;
            state1 = st.nextToken().trim() ;
	    break ;
      case 'L' :
      case 'R' : state1 = st.nextToken().trim() ;
            break ;
    }
  }

  public String print () throws Exception {
    String str = kind + " " ;
    switch ( kind ) {
      case '!' : break ;
      case '?' : str += value + ", " + state1 + ", " + state2 ;
	    break ;
      case 'M' :
      case '>' : str += value + ", " + state1 ;
	    break ;
      case 'L' :
      case 'R' : str += state1 ;
            break ;
    }
    return str ;
  }

}
